package sample;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

@Entity
public class GlobalAccount extends StoredObject {

    private static final long serialVersionUID = 1L;

    @Column(name = "ACCOUNT_ID", unique = true, nullable = false)
    private String accountId;

    @Column(name = "COMMENT")
    private String comment;

    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "globalAccount")
    private List<RoleAssignment> roleAssignments = Collections.emptyList();

    public String getAccountId() {
        return accountId;
    }

    public void setAccountId(String accountId) {
        this.accountId = accountId;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public List<Role> getRoles() {
        List<Role> roles = new ArrayList<Role>(roleAssignments.size());
        for (RoleAssignment roleAssignment : roleAssignments) {
            roles.add(roleAssignment.getRole());
        }
        return roles;
    }

    public void setRoles(List<Role> roles) {
        List<RoleAssignment> roleAssignments = new ArrayList<RoleAssignment>(roles.size());
        for (int i = 0; i < roles.size(); i++) {
            roleAssignments.add(new RoleAssignment(roles.get(i), this, i));
        }
        this.roleAssignments = roleAssignments;
    }

    @Override
    public String toString() {
        return String.format("GlobalAccount(oid:%d, version:%d, accountID:'%s', roles:%s)", getOid(), getVersion(), getAccountId(), getRoles());
    }
}
