package sample;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Stateless
public class RoleManagerBean implements RoleManager {

    @PersistenceContext
    EntityManager entityManager;

    public Role create(Role role) {
        entityManager.persist(role);
        return role;
    }

    public Role delete(String roleName) {
        Role role = get(roleName);
        entityManager.remove(role);
        return role;
    }

    public Role get(String roleName) {
        Role role = (Role) entityManager.createQuery("SELECT e FROM Role e WHERE e.name = :value")
                .setParameter("value", roleName).getSingleResult();
        return role;
    }
}
