package sample;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Version;

@MappedSuperclass
public abstract class StoredObject implements Serializable {

    @Id
    @Column(name = "OID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long oid;

    @Version
    @Column(name = "VERSION")
    private int version;

    public Long getOid() {
        return oid;
    }

    public int getVersion() {
        return version;
    }
}
